- Main Page
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# DependencyHyperedge Class Reference

Inheritance diagram for DependencyHyperedge:

[legend]
Collaboration diagram for DependencyHyperedge:

[legend]
List of all members.

## Public Member Functions
| DependencyHyperedge ()
virtual | ~DependencyHyperedge ()
void | addReference ()
void | releaseReference ()
int | addNode (DependencyNode *node)
DependencyNode & | operator[] (unsigned int index) throw (DependencyArrayIndexOutOfBoundsException)
unsigned int | getNumberOfNodes () const
bool | isVisited () const
void | setVisited (bool newVisited=true)
bool | operator== (DependencyHyperedge const &other) const
void | print (ostream &out) const
## Protected Attributes
DynamicArrayTemplate< DependencyNode > | nodes
| The dependency nodes that this edge points to.
bool | visited
| The visited status of this hyperedge.
unsigned int | references
| The current number of references to this object.

## Detailed Description

A hyperedge that contains a list of Dependency nodes to which it points. The hyperedge can be marked when it is visted.

Definition at line 346 of file CompileSATDriver.cpp.

## Constructor & Destructor Documentation

DependencyHyperedge::DependencyHyperedge | ( |  | ) |

Creates a new, empty hyperedge.

Definition at line 597 of file CompileSATDriver.cpp.

References references, and visited.

DependencyHyperedge::~DependencyHyperedge | ( |  | ) | `[virtual]`

Destroys this object

Definition at line 607 of file CompileSATDriver.cpp.

## Member Function Documentation

void DependencyHyperedge::addReference | ( |  | ) |

Increases the edge reference count. The edge should later be released and will delete itself when the reference count reaches 0. The reference count starts at 0.

Definition at line 613 of file CompileSATDriver.cpp.

References references.

Referenced by DependencyNode::addConnection().

void DependencyHyperedge::releaseReference | ( |  | ) |

Decreases the reference count. When this reaches 0 (or is already 0), this object will delete itself.

Definition at line 620 of file CompileSATDriver.cpp.

References references.

Referenced by DependencyNode::addConnection(), and DependencyNode::removeConnection().

int DependencyHyperedge::addNode | ( | DependencyNode * | node | ) |

Adds an extra dependency node to this object

Parameters:

  | node | the node being added to this object. Note that this object does not assume ownership of the node.

Returns:
  0 if the node was added successfully, or a positive number if the node could not be added

Definition at line 632 of file CompileSATDriver.cpp.

References nodes.

DependencyNode& DependencyHyperedge::operator[] | ( | unsigned int | index | ) | throw (DependencyArrayIndexOutOfBoundsException)`[inline]`

returns the node at the specified location

Parameters:

  | index | the index of the node to return

Exceptions:

  | DependencyArrayOutOfBoundsException | if the array index exceeded the number of nodes.

Definition at line 386 of file CompileSATDriver.cpp.

References nodes.

unsigned int DependencyHyperedge::getNumberOfNodes | ( |  | ) | const`[inline]`

returns the number of nodes in this hyperedge

Returns:
  the number of nodes linked by this hyperedge

Definition at line 400 of file CompileSATDriver.cpp.

References nodes.

bool DependencyHyperedge::isVisited | ( |  | ) | const

Returns true if this hyperedge has been visited already

Returns:
  true if this hyperedge has been visited.

Definition at line 648 of file CompileSATDriver.cpp.

References visited.

void DependencyHyperedge::setVisited | ( | bool | newVisited = `true` | ) |

sets the visited status of this hyperedge.

Parameters:

  | newVisited | the new visited status of this hyperedge

Definition at line 655 of file CompileSATDriver.cpp.

References visited.

bool DependencyHyperedge::operator== | ( | DependencyHyperedge const & | other | ) | const

Returns true if the two hyperedges are the same.

Parameters:

  | other | the other object being compared to this object.

Returns:
  true if the two objects are the same.

Definition at line 663 of file CompileSATDriver.cpp.

void DependencyHyperedge::print | ( | ostream & | out | ) | const`[virtual]`

called to print this object to the specified ostream.

Parameters:

  | out | the ostream to print this object information to

Implements Mers::Utils::Lang::BaseModelObject.

Definition at line 673 of file CompileSATDriver.cpp.

References nodes, and visited.

The documentation for this class was generated from the following file:

- /Users/fpy/titan-1-5-MBARI/Mers/Solvers/SAT/GATSAT/CompileSAT/CompileSATDriver.cpp